/*
  Corretor para problema Parque Jurassico -- Seletiva IOI 2003
  por Guilherme Ottoni
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define MIN(X,Y) ((X)<(Y)?(X):(Y))
#define TAM 110

void erro(char * msg)
{
  fprintf(stderr,"%s\n",msg);
  printf("0\n");
  exit(0);
}

int tam_resposta(char *seq1, char *seq2)
{
  char *s1 = seq1 - 1;
  char *s2 = seq2 - 1;
  int i1, i2;
  int tab[TAM][TAM];

  for (i1 = 0; i1 <= strlen(seq1); i1++)
    tab[i1][0] = i1;
  for (i2 = 0; i2 <= strlen(seq2); i2++)
    tab[0][i2] = i2;
  for (i1 = 1; i1 <= strlen(seq1); i1++)
    for (i2 = 1; i2 <= strlen(seq2); i2++)
      if (s1[i1] == s2[i2])
	tab[i1][i2] = tab[i1-1][i2-1] + 1;
      else
	tab[i1][i2] = MIN(tab[i1-1][i2], tab[i1][i2-1]) + 1;
  return tab[strlen(seq1)][strlen(seq2)];
}

int subseq(char *s, char *super)
{
  int i=0, is=0;
  while (i < strlen(s) && is < strlen(super))
    {
      while (is < strlen(super) && super[is] != s[i])
	is++;
      if (super[is] == s[i])
	{
	  is++; 
	  i++;
	}
    }
  return i == strlen(s);
}

void strlwr(char *s)
{
  int i;
  for (i = 0; i < strlen(s); i++)
    s[i] = tolower(s[i]);
}

int main(int argc, char *argv[])
{
  FILE *sol_aluno;
  int nteste=1, caso_aluno;
  char linha_aluno[10000], seq1[TAM], seq2[TAM], msg_erro[1000];

  sol_aluno = fopen(argv[1], "rt");
  
  while (scanf("%s %s", seq1, seq2) == 2)
    {
      strlwr(seq1);
      strlwr(seq2);
      if ((fscanf(sol_aluno,"%s",linha_aluno) != 1) ||
          ((strcmp(linha_aluno,"teste") && strcmp(linha_aluno,"Teste"))))
        erro("Palavra 'Teste' nao encontrada");
      if ((fscanf(sol_aluno,"%d",&caso_aluno) != 1) || (caso_aluno != nteste++))
        erro("Nro do teste incorreto");
      if (fscanf(sol_aluno, "%s", linha_aluno) != 1)
	  erro("Final inesperado da resposta");
      strlwr(linha_aluno);
      if (strlen(linha_aluno) != tam_resposta(seq1, seq2))
	{
	  sprintf(msg_erro, "Resposta para o Teste %d nao eh otima", 
		  nteste-1);
	  erro(msg_erro);
	}
      if (!subseq(seq1, linha_aluno) || !subseq(seq2, linha_aluno))
	{
	  sprintf(msg_erro, "Resposta para o Teste %d nao eh supersequencia das sequencias da entrada", nteste-1);
	  erro(msg_erro);
	}
    }
  if (fscanf(sol_aluno, "%s", linha_aluno) == 1)
    erro("Final da resposta esperado");
  printf("10\n");
  fclose(sol_aluno);
  return 0; 
}
